Index: www/xhp/ia/sidebar.php
new file mode 100644
===================================================================
--- www/xhp/ia/sidebar.php	(revision 0)
+++ www/xhp/ia/sidebar.php	(working copy)
@@ -0,0 +1,144 @@
+<?php
+// Contains XHP objects for the site's left side bar.
+
+require_once(IA_ROOT_DIR . 'www/xhp/ia/login_form.php');
+require_once(IA_ROOT_DIR . 'www/xhp/ui/list.php');
+require_once(IA_ROOT_DIR . 'www/wiki/wiki.php');
+require_once(IA_ROOT_DIR . 'www/xhp/ui/textblock.php');
+
+class :ia:left-col extends :x:element {
+    attribute
+        array user;
+
+    protected function render() {
+        $user = $this->getAttribute('user');
+        foreach ($this->getChildren('ia:left-navbar') as $child) {
+            $child->setAttribute('user', $user);
+        }
+        return
+          <div id="sidebar">
+            {$this->getChildren()}
+          </div>;
+    }
+}
+
+class :ia:left-navbar extends :x:element {
+    attribute
+        array user;
+    children empty;
+
+    protected function render() {
+        $user = $this->getAttribute('user');
+        $list =
+          <ui:list id="nav" class="clear">
+            <ui:link href={url_home()}>
+              Home
+            </ui:link>
+
+            <ui:link href={url_textblock('arhiva')} accesskey="a">
+              Arhiva de probleme
+            </ui:link>
+            <ui:link href={url_textblock('arhiva-educationala')}>
+              Arhiva educatională
+            </ui:link>
+            <ui:link href={url_textblock('concursuri')}>
+              Concursuri
+            </ui:link>
+            <ui:link href={url_textblock('concursuri-virtuale')}>
+              Concursuri virtuale
+            </ui:link>
+            <ui:link href={url_textblock('clasament-rating')}>
+              Clasament
+            </ui:link>
+            <ui:link href={url_textblock('articole')}>
+              Articole
+            </ui:link>
+            <ui:link href={url_textblock('downloads')}>
+              Downloads
+            </ui:link>
+            <ui:link href={url_textblock('links')}>
+              Links
+            </ui:link>
+            <ui:link href={url_textblock('documentatie')}>
+              Documentaţie
+            </ui:link>
+            <ui:link href={url_textblock('despre-infoarena')}>
+              Despre infoarena
+            </ui:link>
+            <li class="separator">
+              <hr/>
+            </li>
+          </ui:list>;
+
+        if ($user) {
+            $list->appendChild(
+                <ui:link
+                  href={url_monitor(array('user' => $user['username']))}
+                  accesskey="m">
+                  Monitorul de evaluare
+                </ui:link>);
+            $list->appendChild(
+                <ui:link href={url_submit()}>
+                  <strong>Trimite soluţii</strong>
+                </ui:link>);
+            $list->appendChild(
+                <ui:link href={url_account()} accesskey="c">
+                  Contul meu
+                </ui:link>);
+        } else {
+            $list->appendChild(
+                <ui:link href={url_monitor()} accesskey="m">
+                  Monitorul de evaluare
+                </ui:link>);
+        }
+
+        return $list;
+    }
+}
+
+class :ia:sidebar-ad extends :x:element {
+    children empty;
+
+    protected function render() {
+        $sidebar = textblock_get_revision(IA_SIDEBAR_PAGE);
+        if (!$sidebar) {
+            return <x:frag />;
+        }
+
+        $sidebar['text'] = wiki_process_textblock($sidebar);
+
+        return
+          <ui:textblock class="ad" show_forum={false} textblock={$sidebar} />;
+    }
+}
+
+class :ia:sidebar-login extends :x:element {
+    attribute
+        bool show_login_form = true;
+    children empty;
+
+    protected function render() {
+        if ($this->getAttribute('show_login_form')) {
+            $form = <ia:login-form />;
+        } else {
+            $form = <x:frag />;
+        }
+
+        $extra =
+          <p>
+            <ui:link href={url_register()}>
+              Mă înregistrez!
+            </ui:link>
+            <br />
+            <ui:link href={url_resetpass()}>
+              Mi-am uitat parola...
+            </ui:link>
+          </p>;
+
+        return
+          <div id="login">
+            {$form}
+            {$extra}
+          </div>;
+    }
+}
Index: www/xhp/ia/sitewide.php
new file mode 100644
===================================================================
--- www/xhp/ia/sitewide.php	(revision 0)
+++ www/xhp/ia/sitewide.php	(working copy)
@@ -0,0 +1,210 @@
+<?php
+// Contains important XHP objects that are needed to render the website's
+// frame, such as the website header, footer and navigation bar.
+
+require_once(IA_ROOT_DIR . 'www/xhp/ui/link.php');
+require_once(IA_ROOT_DIR . 'www/xhp/ui/list.php');
+require_once(IA_ROOT_DIR . 'www/xhp/ui/user.php');
+
+class :ia:header:userbox extends :x:element {
+    attribute
+        array user      @required;
+    children empty;
+
+    protected function render() {
+        $user = $this->getAttribute('user');
+        $username = $user['username'];
+
+        return
+          <div id="userbox">
+            <ui:link:user user={$user}>
+              <ui:user:avatar size="normal"/>
+            </ui:link:user>
+            <div class="user">
+              <strong>
+                {$user['full_name']}
+              </strong>
+
+              <br />
+
+              <ui:user:rating-badge user={$user} />
+
+              <ui:link:user user={$user} accesskey="p">
+                {$username}
+              </ui:link:user>
+
+              <br />
+
+              <ui:link:post href={url_logout()} class="logout" post_data={array()} accesskey="l">
+                logout
+              </ui:link:post>
+              |
+              <ui:link href={url_account()} accesskey="c">contul meu</ui:link>
+            </div>
+          </div>;
+    }
+}
+
+class :ia:header extends :x:element {
+    attribute
+        array user;
+    children empty;
+
+    protected function render() {
+        $header = <div id="header" class="clear" />;
+
+        $user = $this->getAttribute('user');
+        if ($user) {
+            $header->appendChild(<ia:header:userbox user={$user} />);
+        }
+
+        if (IA_DEVELOPMENT_MODE) {
+            $header->appendChild(
+              <div id="dev_warning">
+                Bravely working in development mode&hellip;<br/>Keep it up!
+              </div>);
+        }
+
+        $header->appendChild(
+          <h1>
+            <ui:link href={url_home()}>
+              infoarena informatica de performanta
+            </ui:link>
+          </h1>);
+
+        return $header;
+    }
+}
+
+class :ia:top-navbar extends :x:element {
+    attribute
+        array user,
+        int user_pm_count = 0,
+        string selected = "infoarena";
+    children empty;
+
+    protected function render() {
+        $fields = array(
+          'infoarena' =>
+            <ui:link href={url_home()}>info<em>arena</em></ui:link>,
+          'blog' => <ui:link href={url_blog()} accesskey="b">blog</ui:link>,
+          'forum' => <ui:link href={url_forum()} accesskey="f">forum</ui:link>,
+          'calendar' =>
+            <ui:link href={url_forum() . '?action=calendar'}>
+              calendar
+            </ui:link>,
+        );
+
+        $user = $this->getAttribute('user');
+        if (!$user) {
+            $fields['login'] =
+              <ui:link href={url_login()}>autentificare</ui:link>;
+            $fields['register'] =
+              <ui:link href={url_login()}>inregistrare</ui:link>;
+        } else {
+            $fields['profile'] =
+              <ui:link href={url_user_profile($user['username'])}
+                accesskey="p">profilul meu</ui:link>;
+
+            $user_pm_count = $this->getAttribute('user_pm_count');
+            if ($user_pm_count) {
+                $pm_content = <strong>mesaje ({$user_pm_count})</strong>;
+            } else {
+                $pm_content = 'mesaje';
+            }
+            $fields['pm'] =
+              <ui:link href={url_forum() . '?action=pm'}>
+                {$pm_content}
+              </ui:link>;
+
+            if ($user['security_level'] === 'admin') {
+                $fields['smf_admin'] =
+                  <ui:link href={url_forum() . '?action=admin'}>
+                    forum admin
+                  </ui:link>;
+            }
+        }
+
+        $selected = $this->getAttribute('selected');
+        $list = <ul />;
+        foreach ($fields as $name => $content) {
+            if ($selected === $name) {
+                $content = <strong>{$content}</strong>;
+            }
+            $list->appendChild(<li>{$content}</li>);
+        }
+
+        return
+          <div id="topnav">
+            {$list}
+          </div>;
+    }
+}
+
+class :ia:footer extends :x:element {
+    children empty;
+
+    protected function render() {
+        $elem =
+          <div id="footer">
+            <ui:list class="clear">
+              <li class="copyright">&copy;&nbsp;2004-{date("Y")}&nbsp;
+                <ui:link href={url_textblock('Asociatia-infoarena')}>
+                  Asociatia infoarena
+                </ui:link>
+              </li>
+              <li class="separate">
+                <ui:link href={url_home()}>Prima pagina</ui:link>
+              </li>
+              <ui:link href={url_textblock('despre-infoarena')}>
+                Despre infoarena
+              </ui:link>
+              <ui:link href={url_textblock('termeni-si-conditii')}>
+                Termeni si conditii
+              </ui:link>
+              <ui:link href={url_textblock('contact')}>
+                Contact
+              </ui:link>
+              <li class="top">
+                <ui:link href="#header">
+                  Sari la inceputul paginii &uarr;
+                </ui:link>
+              </li>
+            </ui:list>
+          </div>;
+
+        if (!IA_DEVELOPMENT_MODE) {
+            $elem->appendChild(
+            <p class="cc">
+              {HTML('<!--Creative Commons License-->')}
+              <ui:link class="badge" rel="license" href="http://creativecommons.org/licenses/by-nc/2.5/"><img alt="Creative Commons License" src={url_static('images/CreativeCommonsBadge.png')} /></ui:link>
+              Cu exceptia cazurilor in care se specifica altfel, continutul site-ului infoarena<br/>este publicat sub licenta <ui:link rel="license" href="http://creativecommons.org/licenses/by-nc/2.5/">Creative Commons Attribution-NonCommercial 2.5</ui:link>.
+              {HTML('<!--/Creative Commons License-->
+                <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#">
+                  <Work rdf:about="">
+                    <license rdf:resource="http://creativecommons.org/licenses/by-nc/2.5/" />
+                  </Work>
+                  <License rdf:about="http://creativecommons.org/licenses/by-nc/2.5/">
+                    <permits rdf:resource="http://web.resource.org/cc/Reproduction"/>
+                    <permits rdf:resource="http://web.resource.org/cc/Distribution"/>
+                    <requires rdf:resource="http://web.resource.org/cc/Notice"/>
+                    <requires rdf:resource="http://web.resource.org/cc/Attribution"/>
+                    <prohibits rdf:resource="http://web.resource.org/cc/CommercialUse"/>
+                    <permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/>
+                  </License>
+                </rdf:RDF>')}
+            </p>);
+
+            $elem->appendChild(
+              <script src="http://www.google-analytics.com/urchin.js" type="text/javascript" />);
+            $elem->appendChild(
+              <script type="text/javascript">
+                _uacct = 'UA-113289-8';
+                _udn = 'infoarena.ro';
+                urchinTracker();
+              </script>);
+        }
+
+        return $elem;
+    }
+}
Index: www/xhp/ia/user_count.php
new file mode 100644
===================================================================
--- www/xhp/ia/user_count.php	(revision 0)
+++ www/xhp/ia/user_count.php	(working copy)
@@ -0,0 +1,12 @@
+<?php
+
+class :ia:user-count extends :x:element {
+    children empty;
+
+    protected function render() {
+        return
+          <p class="user-count">
+            {user_count()} membri înregistraţi
+          </p>;
+    }
+}
Index: www/xhp/ui/base.php
new file mode 100644
===================================================================
--- www/xhp/ui/base.php	(revision 0)
+++ www/xhp/ui/base.php	(working copy)
@@ -0,0 +1,28 @@
+<?php
+
+class :ui:element extends :x:element {
+    // TODO: facebook was doing cool stuff with CSS margin and padding in ui
+    // elements
+
+    final public function sendAttributes($destination, $attributes = null) {
+        if ($attributes == null) {
+            $attributes = array_keys($this -> getAttributes());
+        }
+
+        if (is_array($attributes)) {
+            foreach ($attributes as $attribute) {
+                $this -> sendAttributes($destination, $attribute);
+            }
+        } elseif ($this -> getAttribute($attributes) &&
+                  method_exists($destination, 'hasAttribute') &&
+                  $destination -> hasAttribute($attributes)) {
+
+                if ($attributes == 'class') {
+                    $destination -> addClass($this -> getAttribute('class'));
+                } else {
+                    $destination -> setAttribute($attributes,
+                        $this -> getAttribute($attributes));
+                }
+        }
+    }
+}
Index: www/xhp/ui/breadcrumbs.php
new file mode 100644
===================================================================
--- www/xhp/ui/breadcrumbs.php	(revision 0)
+++ www/xhp/ui/breadcrumbs.php	(working copy)
@@ -0,0 +1,42 @@
+<?php
+
+require_once(IA_ROOT_DIR . 'www/xhp/ui/base.php');
+
+class :ui:breadcrumbs extends :ui:element {
+    attribute
+        array entries,
+        string current,
+        string title = "Pagini recente";
+    children empty;
+
+    protected function render() {
+        $entries = $this->getAttribute('entries');
+        $current = $this->getAttribute('current');
+
+        if (count($entries) <= 1) {
+            return <x:frag />;
+        }
+
+        $elem =
+          <div class="breadcrumbs">
+            {$this->getAttribute('title')} &raquo;
+          </div>;
+        $first = true;
+        foreach ($entries as $key => $entry) {
+            list($url, $title) = $entry;
+
+            if (!$first) {
+                $elem->appendChild(<span class="separator"> | </span>);
+            } else {
+                $first = false;
+            }
+
+            if ($current == $key) {
+                $elem->appendChild(<strong>{$title}</strong>);
+            } else {
+                $elem->appendChild(<a href={$url}>{$title}</a>);
+            }
+        }
+        return $elem;
+    }
+}
Index: www/xhp/ui/button.php
new file mode 100644
===================================================================
--- www/xhp/ui/button.php	(revision 0)
+++ www/xhp/ui/button.php	(working copy)
@@ -0,0 +1,30 @@
+<?php
+
+require_once(IA_ROOT_DIR . 'www/xhp/ui/base.php');
+
+class :ui:button extends :ui:element {
+    attribute
+        :input,
+        enum { "submit", "button" } type = "button",
+        bool important = false;
+
+    protected function render() {
+        $tag = <input value={(string) <x:frag>
+                                        {$this -> getChildren()}
+                                      </x:frag>}
+                   type={$this -> getAttribute('type')}
+                   class="button" />;
+
+        if ($this -> getAttribute('important') == true) {
+            $tag -> addClass('important');
+        }
+
+        if ($this -> getAttribute('class')) {
+            $classes = explode(' ', $this -> getAttribute('class'));
+            foreach ($classes as $class) {
+                $tag -> addClass($class);
+            }
+        }
+        return $tag;
+    }
+}
Index: www/xhp/ui/flash_message.php
new file mode 100644
===================================================================
--- www/xhp/ui/flash_message.php	(revision 0)
+++ www/xhp/ui/flash_message.php	(working copy)
@@ -0,0 +1,13 @@
+<?php
+
+require_once(IA_ROOT_DIR . 'www/xhp/ui/base.php');
+
+class :ui:flash-message extends :ui:element {
+    attribute
+        :div;
+
+    protected function render() {
+        $message = <div class={'flash ' . $this -> getAttribute('class')}> {$this -> getChildren()} </div>;
+        return $message;
+    }
+}
Index: www/xhp/ui/form.php
new file mode 100644
===================================================================
--- www/xhp/ui/form.php	(revision 0)
+++ www/xhp/ui/form.php	(working copy)
@@ -0,0 +1,183 @@
+<?php
+
+require_once(IA_ROOT_DIR . 'www/xhp/ui/base.php');
+
+class :ui:form extends :ui:element {
+    attribute
+        :form,
+        string legend = "",
+        string imageURL = "",
+        array values,
+        array errors,
+        array descriptions,
+        enum { "list", "inline" } type = "list";
+
+    protected function render() {
+        $legend = $this -> getAttribute('legend');
+        $imageURL = $this -> getAttribute('imageURL');
+        $values = $this -> getAttribute('values');
+        $errors = $this -> getAttribute('errors');
+        $descriptions = $this -> getAttribute('descriptions');
+        $type = $this -> getAttribute('type');
+
+        foreach($this -> getChildren() as $child) {
+            if ($child instanceof :ui:form_field) {
+                $name = $child -> getAttribute('name');
+
+                if ($value = getattr($values, $name, '')) {
+                    $child -> setAttribute('value', $value);
+                }
+
+                if ($error = getattr($errors, $name, '')) {
+                    $child -> setAttribute('error', $error);
+                }
+
+                if ($description = getattr($descriptions, $name, '')) {
+                    $child -> setAttribute('description', $description);
+                }
+            }
+        }
+
+        if ($legend || $imageURL) {
+            $title = <legend />;
+            if ($imageURL) {
+                $title -> appendChild(<img src={$imageURL} alt="!" />);
+            }
+
+            if ($legend) {
+                $title -> appendChild(<x:frag>{$legend}</x:frag>);
+            }
+        } else {
+            $title = <x:frag />;
+        }
+
+        if ($type == 'list') {
+            $container =
+              <ui:list class="form">
+                {$this -> getChildren()}
+              </ui:list>;
+        } else {
+            $container =
+              <x:frag>
+                {$this -> getChildren()}
+              </x:frag>;
+        }
+
+        $form =
+          <form>
+            <fieldset>
+              {$title}
+              {$container}
+            </fieldset>
+          </form>;
+
+        $this -> sendAttributes($form);
+
+        return $form;
+    }
+}
+
+abstract class :ui:form_field extends :ui:element {
+    attribute
+        var editor,
+        bool label=true,
+        enum { "normal", "reversed" } order = "normal",
+        string accesskey,
+        string error,
+        string description;
+
+    protected function render() {
+        // Setting the label for the form field
+        if ($this -> getAttribute('label') == true && array_key_exists(0, $this -> getChildren())) {
+            $label =
+              <label for={'form_' . $this -> getAttribute('name')}
+                accesskey={$this -> getAttribute('accesskey')}>
+                <ui:highlight_accesskey accesskey ={$this -> getAttribute('accesskey')}>
+                  {$this -> getChildren()}
+                </ui:highlight_accesskey>
+              </label>;
+        } else {
+            $label = <x:frag />;
+        }
+
+        // Getting any extra errors
+        if ($this -> getAttribute('error')) {
+            $error =
+              <span class="fieldError">
+                {$this -> getAttribute('error')}
+              </span>;
+        } else {
+            $error = <x:frag />;
+        }
+
+        // Getting the editor
+        $editor = $this -> getAttribute('editor');
+
+        // Any extra description
+        if ($this -> getAttribute('description')) {
+            $description =
+              <span class = "fieldHelp">
+                {$this -> getAttribute('description')}
+              </span>;
+        } else {
+            $description = <x:frag />;
+        }
+
+        // Classes
+        $editor -> setAttribute('class', $this -> getAttribute('class'));
+        $this -> sendAttributes($label, 'class');
+
+        if ($this -> getAttribute('order') == "normal") {
+            return
+              <x:frag>
+                {$label}
+                {$error}
+                {$editor}
+                {$description}
+              </x:frag>;
+        }
+
+        return
+          <x:frag>
+            {$description}
+            {$editor}
+            {$error}
+            {$label}
+          </x:frag>;
+    }
+}
+
+class :ui:form:input extends :ui:form_field {
+    attribute
+        :input,
+        enum { "text", "password" } type = "text";
+
+    protected function render() {
+        $editor =
+          <input name={$this -> getAttribute('name')}
+              id={'form_' . $this -> getAttribute('name')}
+              value={$this -> getAttribute('value')}
+              type={$this -> getAttribute('type')} />;
+
+        $this -> setAttribute('editor', $editor);
+        return :ui:form_field::render();
+    }
+}
+
+class :ui:form:checkbox extends :ui:form_field {
+    attribute
+        :input;
+
+    protected function render() {
+        $editor =
+          <input name={$this -> getAttribute('name')}
+              id={'form_' . $this -> getAttribute('name')}
+              checked={$this -> getAttribute('value')}
+              type="checkbox" />;
+
+
+        $this -> sendAttributes($editor, 'checked');
+        $this -> setAttribute('editor', $editor);
+        return :ui:form_field::render();
+    }
+}
Index: www/xhp/ui/link.php
new file mode 100644
===================================================================
--- www/xhp/ui/link.php	(revision 0)
+++ www/xhp/ui/link.php	(working copy)
@@ -0,0 +1,123 @@
+<?php
+
+require_once(IA_ROOT_DIR . 'www/xhp/ui/base.php');
+require_once(IA_ROOT_DIR . 'www/JSON.php');
+
+class :ui:highlight_accesskey extends :ui:element {
+    attribute
+        string accesskey;
+
+    protected function render() {
+        $value = (string)(<x:frag>
+                            {$this -> getChildren()}
+                          </x:frag>);
+        $access_key = $this -> getAttribute('accesskey');
+        if (($pos = stripos($value, $access_key)) !== false) {
+            return
+              <x:frag>
+                {substr($value, 0, $pos)}
+                <span class="access-key">
+                  {$value[$pos]}
+                </span>
+                {substr($value, $pos + 1)}
+              </x:frag>;
+        } else {
+            return
+                <x:frag>
+                    {$value}
+                </x:frag>;
+        }
+    }
+}
+
+class :ui:link extends :ui:element {
+    attribute
+        bool highlight_accesskey = true,    // Whether or not to highlight the
+                                            // link's accesskey if specified.
+        string confirm_request = "",
+        :a;
+
+    protected function render() {
+        $elem = <a>{$this->getChildren()}</a>;
+        $confirm_request = $this -> getAttribute('confirm_request');
+        $accesskey = $this->getAttribute('accesskey');
+
+        if ($accesskey && $this->getAttribute('highlight_accesskey')) {
+            // This assumes that no HTML tags are present inside the link.
+            // If these are present, they will be escaped.
+            $elem = <a>
+                      <ui:highlight_accesskey accesskey={$this -> getAttribute('accesskey')}>
+                        {$this -> getChildren()}
+                      </ui:highlight_accesskey>
+                    </a>;
+        }
+
+        if ($confirm_request) {
+            $elem -> setAttribute('onclick', "return confirm ('" . $confirm_request . "')");
+        }
+        $this -> sendAttributes($elem);
+        return $elem;
+    }
+}
+
+class :ui:link:post extends :ui:link {
+    attribute
+        array post_data;
+
+    protected function render() {
+        $post_data = $this -> getAttribute('post_data');
+        $href = $this -> getAttribute('href');
+
+        $json = new Services_JSON();
+        $href = "javascript:PostData(" . str_replace('"', "'", $json -> encode($href)) . ", " . str_replace('"', "'", $json -> encode($post_data)) . ")";
+        $this -> setAttribute('href', $href);
+        return :ui:link::render();
+    }
+}
+
+class :ui:link:user extends :ui:link {
+    attribute
+        array user @required,
+        enum { "default", "rating", "stats" } page = "default";
+
+    protected function render() {
+        $user = $this -> getAttribute('user');
+        $page = $this -> getAttribute('page');
+        if ($page == "default") {
+            $href = url_user_profile($user['username'], true);
+        } else if ($page == "rating") {
+            $href = url_user_rating($user['username']);
+        } else if ($page == "stats") {
+            $href = url_user_stats($user['username']);
+        }
+        $this -> setAttribute('href', $href);
+
+        foreach ($this -> getChildren() as $child) {
+            $this -> sendAttributes($child, 'user');
+        }
+        return :ui:link::render();
+    }
+}
+
+class :ui:link:pager extends :ui:link {
+    attribute
+        int display_entries = 50,
+        int first_entry = 0,
+        string prefix = "";
+
+    protected function render() {
+        $prefix = $this -> getAttribute('prefix');
+
+        $options = array();
+        $options[$prefix . 'first_entry'] = $this -> getAttribute('first_entry');
+        $options[$prefix . 'display_entries'] = $this -> getAttribute('display_entries');
+
+        $this -> setAttribute('href', url_options_add($options));
+
+        if (count($this -> getChildren()) == 0) {
+            $page = ($this -> getAttribute('first_entry') / $this -> getAttribute('display_entries')) + 1;
+            $this -> appendChild(<x:frag> {$page} </x:frag>);
+        }
+        return :ui:link::render();
+    }
+}
Index: www/xhp/ui/list.php
new file mode 100644
===================================================================
--- www/xhp/ui/list.php	(revision 0)
+++ www/xhp/ui/list.php	(working copy)
@@ -0,0 +1,31 @@
+<?php
+
+require_once(IA_ROOT_DIR . 'www/xhp/ui/base.php');
+
+class :ui:list extends :ui:element {
+    attribute
+        :ul,
+        enum { "unordered", "ordered"} type = "unordered";
+
+    protected function render() {
+        if ($this -> getAttribute('type') == "unordered") {
+            $list = <ul />;
+        } else {
+            $list = <ol />;
+        }
+
+        $this -> sendAttributes($list);
+
+        foreach ($this -> getChildren() as $child) {
+            if ($child instanceof :li) {
+                $list -> appendChild($child);
+            } else {
+                $list -> appendChild(<li>
+                                   {$child}
+                                 </li>);
+            }
+        }
+        return $list;
+    }
+}
+?>
